{
    The P-NAV Project
    R/C Autopilot with OSD 
    paul@hubner.net
    modified by
    earl@uphi.net
    03/19/2009                                                  
}
CON
  
' NAME        PIN#  / VALUE
' ----------- ------- ----------  

  _CLKMODE            = XTAL1 + PLL16X
  _XINFREQ            = 5_000_000

' GPS Assignments                                        
  GPSin     = 08                                        ' fm GPS NEMA data
  GPSout    = 09                                        ' to GPS (to set baud, SIRF or NMEA etc. May be needed for your GPS)
  Nunchuck_Addr = $A4


' Video Output Assignments                              
  TVBase    = 12                                        ' TV  base pin         

' Rx Input Assignments                              
  RxAler    = 4 'pin 4 on rx  aleron
  RxElev    = 5 'pin 5 on rx  elevator
  RxRudder  = 6 'pin 6 on rx  throtle                                                              
  RxThrot   = 7 'pin 7 on rx  rudder
  RxGear    = 11'pin 11 on gear switch
  
' Servos Output pins
  SrvAle    = 19                                        
  SrvRudder = 20                                       
  SrvElev   = 21                                       
  SrvThrot  = 22
                               
  PING_Pin = 10     'for close ground mesurement  
                     
    cEnable = 16    'clock,data,enable pins compass
    cClock = 17
    cData = 18 
 
                                                                                                                
VAR

  long  stackRC[100]                                    ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  long  stackOSD[100]                                   ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  long  rx[ 8]                                          ' FROM r/c receiver from ~0450 to ~1100   
  long sign,ang,ptr,prop_lat,prop_rad                   ' to save stack space
  byte OSD, temp                                              ' use to check if the TV background has been painted once.
  byte buffer [50]

   word rx5
   word rx6
   word rx7
   word rx8
   word accel_x
   word accel_y
   word accel_z
   long _220uS
   byte i2cSCL, i2cSDA
   long time
   long rangeIN
   long rangeMM
   long rangeCM
   long degree
       long CorrectHeading
    long Deg, OldDeg, alt               
     long RawHeading
     word tempF,tempc,BaroP
  word UT,UP,x1,x2,y2,x3,y3,x4,y4,b5,t,p,B3,B4,B6,Y1,altitude
  
OBJ                                                    
  clock      :  "Clock"                                 ' overall timers 
  tv         :  "tv_text"                               ' TV video output driver
  BS2        :  "BS2_Functions"                         ' BS2 Functions for I/O
  gps        :  "GPS_IO_mini_PNAV"                      ' Services GPS input and etrex extension           
  ser        :  "FullDuplexSerial_mini"
  Nun        :  "ECnun"                                 'N-chuck accl data subs
  i2cObject  :  "ECi2c"                                 'i2c comm stuff
  ping       :  "ping"
  HM55B      :  "Sensor.HM55B.Compass"
  Calibrate  :  "HM55B Compass Calibration"
  barom      :  "Testi2CbaroTempPRESS_MODULE"
  
PUB start

''Initialize all necessary routines into their cogs as appropriate
 
Clock.Init(_XINFREQ)                                    ' set up clock for accurate 10/second
Clock.SetClock(_CLKMODE)                                ' video update rate
Clock.MarkSync
tv.start(TVBase)                                        ' start TV display
BS2.Start(30,31)                                        ' start BS2 routines used for servo pulsing

cognew(RC_io,@stackRC)                                  ' start R/C in/out on its own cog
cognew(OSD_Servo,@stackOSD)
gps.start(GPSin,GPSout)                                 ' start GPS ingest (gets its own cog)
Nun.init(28,29)                                         'scl and sda on pin 28 and pin 29 for I2C
HM55B.start(cEnable,cClock,cData)


  DIRA[20]~~                          'make servo pin output
  DIRA[21]~~                          'make servo pin output
  DIRA[22]~~                          'make servo pin output
  DIRA[23]~~                          'make servo pin output

OSD_INI                               ' Print AutoPilot data Layout Screen
                                        
ControlLoop                           ' overall control loop

PUB ControlLoop                       ' primary loop

time := cnt                           'set time to cuttent tic value

      Accl_get                        ' Get Accl xyz inputs and the time to get them in 'time'       

time := cnt - time                    'make 'time' the start time tics - time now tics
'If you divide your clkfreq by the "time" variable, you will get samples per second
time := clkfreq / time                'Samples per Second

      OSD_Servo                       ' Get Radio inputs       
      OSD_GPS1                        ' Print all data on TV
rangeIN := ping.Inches(PING_Pin)                      ' Get Range In Inches
'rangeMM := ping.Millimeters(PING_Pin)                 ' Get Range In MM
'rangeCM := ping.Centimeters(PING_Pin)                 ' Get Range In CM

RawHeading := HM55B.Theta                         ' Read RAW 13-bit Angle

      CorrectHeading := Calibrate.Correct(RawHeading)   ' Calibrate Correct Heading 
            
      Deg := CorrectHeading * 45 / 1024                 ' Convert 13-Bit Angle to Deg
                                                        ' Note: This only makes it easier for us Humans to
                                                        '       read.

    
'*************At this point we have all GPS,accl x-y-z,RX, and servo data ! *************
'We can use the data for stabilization , return home, or goto via gps !
'****************************************************************************************

      waitcnt(250000 + cnt)          ' loop cycle time (~1/4 sec)
                                            
ControlLoop                          'Do everything over and over !

PUB OSD_Servo


Pub OSD_INI

    tv.out($00)  
'                  0         1         2         3        
'                  0123456789012345678901234567890123456789
    tv.str(string("________Propellar AutoPilot Data______ ",13))                'setup the tv screen graphics layout
    tv.str(string("Lock:  x      Compass     BarPrs 29.93 ",13))
    tv.str(string("Latitude:     _xxxx.xxxx  x            ",13))
    tv.str(string("Longitude:    xxxxx.xxxx  x            ",13))
    tv.str(string("Spd:   xxxxx  Alt:xxxxx   Head: xxx    ",13))
    tv.str(string("AutoPilot     Ground Distance In.    ",13))
    tv.str(string("          Pin 4 Aleron",13))
    tv.str(string("          Pin 5 Rudder",13))
    tv.str(string("          Pin 6 Throttle",13))
    tv.str(string("          Pin 7 Elevator",13))
    tv.str(string("Acclerometer    ",13))
  

Pub OSD_GPS1

    'Items are self explanitory:
  tv.str(string($A,7,$B,1))                                
    tv.str(gps.valid)
 tv.str(string($A,22,$B,1))
 tv.str(string("   "))
 tv.str(string($A,22,$B,1))
 tv.dec(deg)                             ' Print Distance in MM
  tv.str(string($A,15,$B,2))                                
    tv.str(gps.latitude)
  tv.str(string($A,26,$B,2))                                
    tv.str(gps.N_S)
  tv.str(string($A,14,$B,3))                                
    tv.str(gps.longitude)
  tv.str(string($A,26,$B,3))                                
    tv.str(gps.E_W)
  tv.str(string($A,7,$B,4))                                
    tv.str(gps.speed)
  tv.str(string($A,18,$B,4))                                
    tv.str(gps.altitude)
  tv.str(string($A,32,$B,4))                                
    tv.str(gps.heading)

  tv.str(string($A,10,$B,5))
    if (rx[7] > 600)
      tv.str(string("On "))
    else
     tv.str(string("Off"))
     
' tv.str(string($A,34,$B,5))
' tv.str(string("   "))
' tv.str(string($A,34,$B,5))
' tv.dec(rangeMM)                              ' Print Distance in MM

'tv.str(string($A,34,$B,5))
' tv.str(string("     "))
'tv.str(string($A,34,$B,5))
'  tv.dec(rangeCM)                              ' Print Distance in CM
        
tv.str(string($A,34,$B,5))
 tv.str(string("     "))
tv.str(string($A,34,$B,5))
  tv.dec(rangeIN)                              ' Print Distance in Inches
        
    tv.str(string(13))
    tv.dec(rx[ 2])         'print  Throttle input                            
    tv.str(string(13))
    tv.dec(rx[ 1])         'print  Elevator input                           
    tv.str(string(13))
    tv.dec(rx[ 3])         'print  Aleiron input                         
    tv.str(string(13))
    tv.dec(rx[ 4])         'print  Rudder input    

      tv.str(string($A,16,$B,10)) 'set tv position to col 16 line 10     
      tv.dec(Nun.accelX)          'Print the decimal # for acceleration X axis
      tv.str(string(" X "))   
      tv.dec(Nun.accelY)      
      tv.str(string(" Y "))  
      tv.dec(Nun.accelZ)         
      tv.str(string(" Z "))   
              tv.str(string($A,1,$B,121))     'set tv position to col 1 line 1     
      tv.str(string("                ")) 'errase most of the line
           tv.str(string($A,1,$B,12))     'set tv position to col 1 line 1     
      tv.str(string("TempC > "))
      tv.dec(TempC)                      'Print the decimal # for Temprature in F  
      tv.str(string("  TempF > "))         'Print this...
      tv.dec(TempF)                      'Print the decimal # for Temprature in F  
      tv.str(string(" Press hPa > "))         'Print this...
      tv.dec(BaroP)                      'Print the decimal # for Temprature in F  
 
'PUB atoi( pptr,c)| ptrr                                ' convert c characters into number
' result := sign := 0
' if byte[pptr] == "-"
'     sign++
'     pptr++
'  c--    
' repeat ptrr from 0 to c
'   if byte[pptr+ptrr] == 0                             ' stop if null
'        quit
         
 '  if byte[pptr+ptrr] == "."                           ' stop if decimal point
'        quit
'   else     
'      result := result * 10 + (byte[pptr+ptrr] - "0")
' if sign == 1
'   result := -result

PUB RC_IO
repeat
                                        ' Get Radio Inputs
   rx[ 1] := BS2.PULSIN( RxAler,1)      ' aleron      
   rx[ 2] := BS2.PULSIN( RxElev,1)      ' elevator
   rx[ 3] := BS2.PULSIN( RxThrot,1)     ' throttle            
   rx[ 4] := BS2.PULSIN( RxRudder,1)    ' rudder          

    rx[ 7] := BS2.PULSIN( RxGear,1)     ' Gear input switch 550 = down 965 = up
                
    BS2.PULSOUT(SrvAle,rx[ 2] )         'output to servos
    BS2.PULSOUT(SrvRudder,rx[ 1] )
    BS2.PULSOUT(SrvElev,rx[ 3] )
    BS2.PULSOUT(SrvThrot,rx[ 4] )

PUB init

   Nun.init(28,29)                'scl and sda on pin 28 and pin 29
   
PUB Accl_get

Nun.readNunchuck        'Get the data via i2c bus

waitcnt(clkfreq /20+ cnt)

PUB readNunchuck | data[6]

   i2cObject.writelocation(Nunchuck_Addr, $0, $00)
   waitcnt(_220uS+cnt)
   i2cObject.i2cStart
   i2cObject.i2cWrite(Nunchuck_Addr)
   i2cObject.i2cWrite(0)
   i2cObject.i2cStop
   waitcnt(_220uS+cnt)
   i2cObject.i2cStart
   i2cObject.i2cWrite(Nunchuck_Addr|1)
   data[0] := (i2cObject.i2cRead(0) ^ $17) + $17 
   data[1] := (i2cObject.i2cRead(0) ^ $17) + $17 
   data[2] := (i2cObject.i2cRead(0) ^ $17) + $17 'accl x value decoded
   data[3] := (i2cObject.i2cRead(0) ^ $17) + $17 'accl y value decoded
   data[4] := (i2cObject.i2cRead(0) ^ $17) + $17 'accl z value decoded
   data[5] := (i2cObject.i2cRead(1) ^ $17) + $17 'lower bits of xyz data
   i2cObject.i2cStop
   accel_x := data[2] << 2
   accel_y := data[3] << 2
   accel_z := data[4] << 2
   if (data[5] >> 2) & 1
      accel_x += 2                                                                               
   if (data[5] >> 3) & 1
      accel_x += 1                                                                               
   if (data[5] >> 4) & 1
      accel_y += 2                                                                               
   if (data[5] >> 5) & 1
      accel_y += 1                                                                               
   if (data[5] >> 6) & 1
      accel_z += 2                                                                               
   if (data[5] >> 7) & 1
      accel_z += 1


PUB accelX
   return accel_x

PUB accelY
   return accel_y

PUB accelZ
   return accel_z