CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
F1 = 40851
F2 = 29891
F3 = 21009
F4 = 38946

AC1 = 8083
AC2 = 234
AC3 = 195
AC4 = 4625
AC5 = 74
AC6 = 2082

B1  = 6114
B2  = 47
OBJ
  Baro  : "EC_i2c_readbaro"
  tv   : "tv_text"

VAR
  word tempF,tempc,BaroP
  word UT,UP,x1,x2,y2,x3,y3,x4,y4,b5,t,p,B3,B4,B6,Y1,altitude
PUB init

   Baro.init(28,29)                'scl and sda on pin 28 and pin 29
   tv.start(12)                    ' start TV display  base pin 12
   mainLoop
PUB mainLoop

    repeat
                                    ' Get raw UT
          Baro.start_adcTemp                                  ' start the adc for reading temp then
          Baro.readBaro                                       ' read data via i2c bus
          UT := ((baro.baro_f6 * 255) + baro.baro_f7)         'raw 16 bit temp data now in UT
      
                                   ' Get raw UP
          Baro.start_adcPres                                  ' start the adc for reading temp then
          Baro.readBaro                                       ' read data via i2c bus
          UP := ((baro.baro_f6 * 255) + baro.baro_f7)         'raw 16 bit temp data now in UP
      
                              '****** Calculate Temp *****

      X1 := UT * 64385 / 65535 - (AC6 + 1415) * 8             'X1 =  4310
      X2 := (X1 * X1) / 8192                                  'X2 =  2267
      Y2 := (-4955 * X2) / 8192                               'Y2 = -1372
      X3 := (X2 * X1) / 65535                                 'X3 =   149
      Y3 := (11611 * X3) / 4096                               'Y3 =   422
      X4 := (X2 * X2) / 65535                                 'X4 =    78
      Y4 := (-12166 * X4) / 16386                             'Y4 =   -58
      B5 := (AC5 + 496)* (2 * (X1 + Y2 + Y3 + Y4))/ 1024      'B5 =  4237
      T  := (B5 + 8) / 8                                      'T =    265  T is degrees C times 10
      tempC := T / 100
      tempF := (t/100) * 9 / 5 + 32                            'convert degrees C to degrees F
     
                             '****** Calculate coefficients B3 and B4 *****
     
     B6 := B5 - 4000                                    ' B6 = 237
       X1 := (B2 * (B6 * B6 / 4096 )) / 2048              ' X1 = 0
       X2 := (AC2 - 457) * B6 / 512                       ' X2 = -103
       X3 := ((X1 + X2) + 2) / 2                          ' X3 = -26
       B3 := (AC1 - 2218) * 2 + X3                        ' B3 = 11704
       Y1 := (AC3 - 1984) * B6 / 1024                     ' Y1 = -415
       Y2 := (B1 * (B6 * B6 / 4096 )) / 65535             ' Y2 = 1
       Y3 := ((Y1 + Y2) + 2) / 2                          ' Y3 = -103
       B4 := (AC4 + 8808) * (Y3 + 32768) / 16386          ' B4 = 26781
       
                             '****** Calculate True Pressure *****
       
       p  := ((UP - B3) * 100000) / B4                    ' p  =  95732
       X1 := (p / 255 ) * (p / 255 )                      ' X1 = 139129
       X1 := (X1 * 3038) / 65535                          ' X1 = 6449
       X2 := (- 7357 * p) / 65535                         ' X2 = -10747
       p := p + (X1 + X2 + 3791) / 8                      ' p = 95700
       
       BaroP := p / 100                                   ' BaroP = 957 hPa
       
     
     
     
     
     
           tv.str(string($A,1,$B,1))     'set tv position to col 1 line 1     
      tv.str(string("                ")) 'errase most of the line
           tv.str(string($A,1,$B,1))     'set tv position to col 1 line 1     
      tv.str(string("TempC > "))
      tv.dec(TempC)                      'Print the decimal # for Temprature in F  
      tv.str(string("  TempF > "))         'Print this...
      tv.dec(TempF)                      'Print the decimal # for Temprature in F  
      tv.str(string(" Press hPa > "))         'Print this...
      tv.dec(BaroP)                      'Print the decimal # for Temprature in F  
     
      tv.str(string($A,1,$B,2))          'set tv position to col 1 line 2      
      tv.str(string("                "))
      tv.str(string($A,1,$B,2))          'set tv position to col 1 line 2
        tv.str(string("X1  "))          'Print this...   
      tv.dec(x1)                         'Print the decimal # for variable X1   
      
      tv.str(string($A,1,$B,3))          'set tv position to col 1 line 3     
      tv.str(string("                ")) 'errase most of the line
      tv.str(string($A,1,$B,3))          'set tv position to col 1 line 3
      tv.str(string("X2  "))            'Print this...   
      tv.dec(x2)                         'Print the decimal # for variable X2 
     
      tv.str(string($A,1,$B,4))          'set tv position to col 1 line 4     
      tv.str(string("                ")) 'errase most of the line 
           tv.str(string($A,1,$B,4))     'set tv position to col 1 line 4     
      tv.str(string("Y2  "))            'Print this...
           tv.dec(y2)                    'Print the decimal # for variable Y2
      
      tv.str(string($A,1,$B,5))          'set tv position to col 1 line 5      
      tv.str(string("                ")) 'errase most of the line 
      tv.str(string($A,1,$B,5))          'set tv position to col 1 line 5
        tv.str(string("X3  "))          'Print this...   
      tv.dec(x3)                         'Print the decimal # for Variable X3 
      
      tv.str(string($A,1,$B,6))          'set tv position to col 1 line 6    
      tv.str(string("                ")) 'errase most of the line   
      tv.str(string($A,1,$B,6))          'set tv position to col 1 line 6
      tv.str(string("Y3  "))            'Print this...   
      tv.dec(y3)                         'Print the decimal # for Variable Y3
       
      tv.str(string($A,1,$B,7))          'set tv position to col 1 line 7     
      tv.str(string("                ")) 'errase most of the line   
           tv.str(string($A,1,$B,7))     'set tv position to col 1 line 7     
      tv.str(string("X4  "))            'Print this...
           tv.dec(x4)                    'Print the decimal # for Variable X4
      
      tv.str(string($A,1,$B,8))          'set tv position to col 1 line 8      
      tv.str(string("                ")) 'errase most of the line   
      tv.str(string($A,1,$B,8))          'set tv position to col 1 line 8
        tv.str(string("Y4  "))          'Print this...   
      tv.dec(y4)                         'Print the decimal # for Variable Y4 
      
        tv.str(string($A,1,$B,9))        'set tv position to col 1 line 9     
      tv.str(string("                ")) 'errase most of the line   
           tv.str(string($A,1,$B,9))     'set tv position to col 1 line 9     
      tv.str(string("B5  "))            'Print this...
           tv.dec(b5)                    'Print the decimal # for Variable B5
      
      tv.str(string($A,1,$B,10))         'set tv position to col 1 line 10      
      tv.str(string("                ")) 'errase most of the line   
      tv.str(string($A,1,$B,10))         'set tv position to col 1 line 10
        tv.str(string("T   "))          'Print this...   
      tv.dec(t)                          'Print the decimal # for  Variable T 
      
     tv.str(string($A,1,$B,11))        'set tv position to col 1 line 9     
      tv.str(string("                ")) 'errase most of the line   
           tv.str(string($A,1,$B,11))     'set tv position to col 1 line 9     
      tv.str(string("B3  "))            'Print this...
           tv.dec(b3)                    'Print the decimal # for Variable B5
      
      tv.str(string($A,1,$B,12))         'set tv position to col 1 line 10      
      tv.str(string("                ")) 'errase most of the line   
      tv.str(string($A,1,$B,12))         'set tv position to col 1 line 10
        tv.str(string("B4  "))          'Print this...   
      tv.dec(b4)                          'Print the decimal # for  Variable T 
      
